import { CommandRegistry, Command, MenuModelRegistry, SelectionService, MessageService } from '@devpodio/core/lib/common';
import { FrontendApplication, AbstractViewContribution } from '@devpodio/core/lib/browser';
import { WidgetManager } from '@devpodio/core/lib/browser/widget-manager';
import { GitDiffWidget } from './git-diff-widget';
import { OpenerService } from '@devpodio/core/lib/browser';
import { UriCommandHandler, UriAwareCommandHandler } from '@devpodio/core/lib/common/uri-command-handler';
import { GitQuickOpenService } from '../git-quick-open-service';
import { FileSystem } from '@devpodio/filesystem/lib/common';
import URI from '@devpodio/core/lib/common/uri';
import { Git } from '../../common';
import { GitRepositoryProvider } from '../git-repository-provider';
export declare namespace GitDiffCommands {
    const OPEN_FILE_DIFF: Command;
}
export declare class GitDiffContribution extends AbstractViewContribution<GitDiffWidget> {
    protected readonly selectionService: SelectionService;
    protected readonly widgetManager: WidgetManager;
    protected readonly app: FrontendApplication;
    protected readonly quickOpenService: GitQuickOpenService;
    protected readonly fileSystem: FileSystem;
    protected openerService: OpenerService;
    protected readonly notifications: MessageService;
    protected readonly repositoryProvider: GitRepositoryProvider;
    constructor(selectionService: SelectionService, widgetManager: WidgetManager, app: FrontendApplication, quickOpenService: GitQuickOpenService, fileSystem: FileSystem, openerService: OpenerService, notifications: MessageService, repositoryProvider: GitRepositoryProvider);
    registerMenus(menus: MenuModelRegistry): void;
    registerCommands(commands: CommandRegistry): void;
    showWidget(options: Git.Options.Diff): Promise<GitDiffWidget>;
    protected newUriAwareCommandHandler(handler: UriCommandHandler<URI>): UriAwareCommandHandler<URI>;
}
