"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var chai = require("chai");
var content_lines_1 = require("./content-lines");
var chai_1 = require("chai");
chai.use(require('chai-string'));
describe('content-lines', function () {
    it('array-like access of lines without splitting', function () {
        var raw = 'abc\ndef\n123\n456';
        var linesArray = content_lines_1.ContentLines.arrayLike(content_lines_1.ContentLines.fromString(raw));
        chai_1.expect(linesArray[0]).to.be.equal('abc');
        chai_1.expect(linesArray[1]).to.be.equal('def');
        chai_1.expect(linesArray[2]).to.be.equal('123');
        chai_1.expect(linesArray[3]).to.be.equal('456');
    });
    it('works with CRLF', function () {
        var raw = 'abc\ndef\r\n123\r456';
        var linesArray = content_lines_1.ContentLines.arrayLike(content_lines_1.ContentLines.fromString(raw));
        chai_1.expect(linesArray[0]).to.be.equal('abc');
        chai_1.expect(linesArray[1]).to.be.equal('def');
        chai_1.expect(linesArray[2]).to.be.equal('123');
        chai_1.expect(linesArray[3]).to.be.equal('456');
    });
});
