import { ContentLinesArrayLike } from './content-lines';
export declare class DiffComputer {
    computeDiff(previous: ContentLinesArrayLike, current: ContentLinesArrayLike): DiffResult[];
    computeDirtyDiff(previous: ContentLinesArrayLike, current: ContentLinesArrayLike): DirtyDiff;
}
export interface DiffResult {
    value: [number, number];
    count?: number;
    added?: boolean;
    removed?: boolean;
}
export interface DirtyDiff {
    readonly added: LineRange[];
    readonly removed: number[];
    readonly modified: LineRange[];
}
export interface LineRange {
    start: number;
    end: number;
}
