import { MaybePromise } from '@devpodio/core/lib/common/types';
export declare class GitCommitMessageValidator {
    static readonly MAX_CHARS_PER_LINE = 72;
    validate(input: string | undefined): MaybePromise<GitCommitMessageValidator.Result | undefined>;
    protected isLineValid(line: string, index: number): GitCommitMessageValidator.Result | undefined;
    protected maxCharsPerLine(): number;
}
export declare namespace GitCommitMessageValidator {
    type Result = Readonly<{
        message: string;
        status: 'info' | 'success' | 'warning' | 'error';
    }>;
    namespace Result {
        function equal(left: Result | undefined, right: Result | undefined): boolean;
    }
}
