import { ILogger } from '@devpodio/core/lib/common/logger';
import { Event, Emitter } from '@devpodio/core/lib/common/event';
import { Tree } from '@devpodio/core/lib/browser/tree/tree';
import { PreferenceChangeEvent } from '@devpodio/core/lib/browser/preferences/preference-proxy';
import { TreeDecorator, TreeDecoration } from '@devpodio/core/lib/browser/tree/tree-decorator';
import { Git } from '../common/git';
import { WorkingDirectoryStatus } from '../common/git-model';
import { GitFileChange, GitFileStatus } from '../common/git-model';
import { GitPreferences, GitConfiguration } from './git-preferences';
import { GitRepositoryTracker } from './git-repository-tracker';
export declare class GitDecorator implements TreeDecorator {
    readonly id = "theia-git-decorator";
    protected readonly git: Git;
    protected readonly repositories: GitRepositoryTracker;
    protected readonly preferences: GitPreferences;
    protected readonly logger: ILogger;
    protected readonly emitter: Emitter<(tree: Tree) => Map<string, TreeDecoration.Data>>;
    protected enabled: boolean;
    protected showColors: boolean;
    protected init(): void;
    decorations(tree: Tree): Promise<Map<string, TreeDecoration.Data>>;
    readonly onDidChangeDecorations: Event<(tree: Tree) => Map<string, TreeDecoration.Data>>;
    protected fireDidChangeDecorations(event: (tree: Tree) => Map<string, TreeDecoration.Data>): void;
    protected collectDecorators(tree: Tree, status: WorkingDirectoryStatus): Map<string, TreeDecoration.Data>;
    protected appendContainerChanges(tree: Tree, changes: GitFileChange[]): Map<string, GitFileChange>;
    protected toDecorator(change: GitFileChange): TreeDecoration.Data;
    protected compare(left: GitFileChange, right: GitFileChange): number;
    protected getDecorationColor(status: GitFileStatus, staged?: boolean): string;
    protected handlePreferenceChange(event: PreferenceChangeEvent<GitConfiguration>): Promise<void>;
}
