import { GitFileStatus, GitFileChange } from '../common';
import URI from '@devpodio/core/lib/common/uri';
import { GitRepositoryProvider } from './git-repository-provider';
import { LabelProvider } from '@devpodio/core/lib/browser/label-provider';
import { Message } from '@phosphor/messaging';
import { ReactWidget } from '@devpodio/core/lib/browser/widgets/react-widget';
import * as React from 'react';
export declare abstract class GitNavigableListWidget<T extends {
    selected?: boolean;
}> extends ReactWidget {
    protected gitNodes: T[];
    private _scrollContainer;
    protected readonly repositoryProvider: GitRepositoryProvider;
    protected readonly labelProvider: LabelProvider;
    constructor();
    protected onActivateRequest(msg: Message): void;
    protected scrollContainer: string;
    protected onUpdateRequest(msg: Message): void;
    protected getStatusCaption(status: GitFileStatus, staged?: boolean): string;
    protected getAbbreviatedStatusCaption(status: GitFileStatus, staged?: boolean): string;
    protected relativePath(uri: URI | string): string;
    protected getRepositoryLabel(uri: string): string | undefined;
    protected computeCaption(fileChange: GitFileChange): string;
    protected renderHeaderRow({ name, value, classNames }: {
        name: string;
        value: React.ReactNode;
        classNames?: string[];
    }): React.ReactNode;
    protected addGitListNavigationKeyListeners(container: HTMLElement): void;
    protected navigateLeft(): void;
    protected navigateRight(): void;
    protected navigateUp(): void;
    protected navigateDown(): void;
    protected handleListEnter(): void;
    protected getSelected(): T | undefined;
    protected selectNode(node: T): void;
    protected selectNextNode(): void;
    protected selectPreviousNode(): void;
    protected readonly indexOfSelected: number;
}
