import { Git, Repository } from '../common';
import { WorkspaceService } from '@devpodio/workspace/lib/browser/workspace-service';
import { FileSystem } from '@devpodio/filesystem/lib/common';
import { DisposableCollection, Event, Emitter } from '@devpodio/core';
import { LocalStorageService } from '@devpodio/core/lib/browser';
import URI from '@devpodio/core/lib/common/uri';
import { FileSystemWatcher } from '@devpodio/filesystem/lib/browser/filesystem-watcher';
export interface GitRefreshOptions {
    readonly maxCount: number;
}
export declare class GitRepositoryProvider {
    protected readonly git: Git;
    protected readonly workspaceService: WorkspaceService;
    protected readonly watcher: FileSystemWatcher;
    protected readonly fileSystem: FileSystem;
    protected readonly storageService: LocalStorageService;
    protected _selectedRepository: Repository | undefined;
    protected _allRepositories?: Repository[];
    protected readonly onDidChangeRepositoryEmitter: Emitter<Repository | undefined>;
    protected readonly selectedRepoStorageKey = "theia-git-selected-repository";
    protected readonly allRepoStorageKey = "theia-git-all-repositories";
    constructor(git: Git, workspaceService: WorkspaceService, watcher: FileSystemWatcher, fileSystem: FileSystem, storageService: LocalStorageService);
    protected readonly toDisposeOnWorkspaceChange: DisposableCollection;
    protected initialize(): Promise<void>;
    protected lazyRefresh: () => Promise<void>;
    selectedRepository: Repository | undefined;
    readonly onDidChangeRepository: Event<Repository | undefined>;
    protected fireDidChangeRepository(): void;
    readonly allRepositories: Repository[];
    findRepository(uri: URI): Repository | undefined;
    findRepositoryOrSelected(arg: URI | string | {
        uri?: string | URI;
    } | undefined): Repository | undefined;
    refresh(options?: GitRefreshOptions): Promise<void>;
    protected exists(repository: Repository): boolean;
}
