import { Git, Repository, WorkingDirectoryStatus } from '../common';
import { Event, Emitter, DisposableCollection } from '@devpodio/core';
import { GitRepositoryProvider } from './git-repository-provider';
import { GitWatcher, GitStatusChangeEvent } from '../common/git-watcher';
import URI from '@devpodio/core/lib/common/uri';
export declare class GitRepositoryTracker {
    protected readonly git: Git;
    protected readonly repositoryProvider: GitRepositoryProvider;
    protected readonly gitWatcher: GitWatcher;
    protected toDispose: DisposableCollection;
    protected workingDirectoryStatus: WorkingDirectoryStatus | undefined;
    protected readonly onGitEventEmitter: Emitter<GitStatusChangeEvent>;
    constructor(git: Git, repositoryProvider: GitRepositoryProvider, gitWatcher: GitWatcher);
    protected init(): Promise<void>;
    readonly selectedRepository: Repository | undefined;
    readonly allRepositories: Repository[];
    readonly selectedRepositoryStatus: WorkingDirectoryStatus | undefined;
    readonly onDidChangeRepository: Event<Repository | undefined>;
    readonly onGitEvent: Event<GitStatusChangeEvent>;
    getPath(uri: URI): string | undefined;
    getUri(path: string): URI | undefined;
    readonly repositoryUri: URI | undefined;
}
