import { WidgetOpenHandler, WidgetOpenerOptions } from '@devpodio/core/lib/browser';
import URI from '@devpodio/core/lib/common/uri';
import { GitCommitDetailWidgetOptions, GitCommitDetailWidget, GitCommitDetails } from './git-commit-detail-widget';
export declare namespace GitCommitDetailUri {
    const scheme = "git-commit-detail-widget";
    function toUri(commitSha: string): URI;
    function toCommitSha(uri: URI): string;
}
export declare type GitCommitDetailOpenerOptions = WidgetOpenerOptions & GitCommitDetailWidgetOptions;
export declare class GitCommitDetailOpenHandler extends WidgetOpenHandler<GitCommitDetailWidget> {
    readonly id = "git-commit-detail-widget";
    canHandle(uri: URI): number;
    protected doOpen(widget: GitCommitDetailWidget, options: GitCommitDetailOpenerOptions): Promise<void>;
    protected createWidgetOptions(uri: URI, commit: GitCommitDetailOpenerOptions): GitCommitDetailWidgetOptions;
    getCommitDetailWidgetOptions(commit: GitCommitDetails): GitCommitDetailWidgetOptions;
}
