import { MenuModelRegistry, CommandRegistry, Command, SelectionService } from '@devpodio/core';
import { AbstractViewContribution, OpenViewArguments } from '@devpodio/core/lib/browser';
import { UriCommandHandler, UriAwareCommandHandler } from '@devpodio/core/lib/common/uri-command-handler';
import URI from '@devpodio/core/lib/common/uri';
import { GitHistoryWidget } from './git-history-widget';
import { GitRepositoryTracker } from '../git-repository-tracker';
import { GitRepositoryProvider } from '../git-repository-provider';
export declare const GIT_HISTORY_ID = "git-history";
export declare const GIT_HISTORY_LABEL = "Git History";
export declare const GIT_HISTORY_TOGGLE_KEYBINDING = "alt+h";
export declare const GIT_HISTORY_MAX_COUNT = 100;
export declare namespace GitHistoryCommands {
    const OPEN_FILE_HISTORY: Command;
    const OPEN_BRANCH_HISTORY: Command;
}
export interface GitHistoryOpenViewArguments extends OpenViewArguments {
    uri: string | undefined;
}
export declare class GitHistoryContribution extends AbstractViewContribution<GitHistoryWidget> {
    protected readonly selectionService: SelectionService;
    protected readonly repositoryTracker: GitRepositoryTracker;
    protected readonly repositoryProvider: GitRepositoryProvider;
    constructor();
    protected init(): void;
    openView(args?: Partial<GitHistoryOpenViewArguments>): Promise<GitHistoryWidget>;
    registerMenus(menus: MenuModelRegistry): void;
    registerCommands(commands: CommandRegistry): void;
    protected refreshWidget(uri: string | undefined): Promise<void>;
    protected newUriAwareCommandHandler(handler: UriCommandHandler<URI>): UriAwareCommandHandler<URI>;
}
