"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var git_history_contribution_1 = require("./git-history-contribution");
var inversify_1 = require("inversify");
var browser_1 = require("@devpodio/core/lib/browser");
var git_history_widget_1 = require("./git-history-widget");
var git_commit_detail_widget_1 = require("./git-commit-detail-widget");
var git_avatar_service_1 = require("./git-avatar-service");
require("../../../src/browser/style/history.css");
require("../../../src/browser/style/git-icons.css");
var git_commit_detail_open_handler_1 = require("./git-commit-detail-open-handler");
function bindGitHistoryModule(bind) {
    bind(git_avatar_service_1.GitAvatarService).toSelf().inSingletonScope();
    bind(git_history_widget_1.GitHistoryWidget).toSelf();
    bind(browser_1.WidgetFactory).toDynamicValue(function (ctx) { return ({
        id: git_history_contribution_1.GIT_HISTORY_ID,
        createWidget: function () { return ctx.container.get(git_history_widget_1.GitHistoryWidget); }
    }); });
    bind(browser_1.WidgetFactory).toDynamicValue(function (ctx) { return ({
        id: git_commit_detail_widget_1.GIT_COMMIT_DETAIL,
        createWidget: function (options) {
            var child = new inversify_1.Container({ defaultScope: 'Singleton' });
            child.parent = ctx.container;
            child.bind(git_commit_detail_widget_1.GitCommitDetailWidget).toSelf();
            child.bind(git_commit_detail_widget_1.GitCommitDetailWidgetOptions).toConstantValue(options);
            return child.get(git_commit_detail_widget_1.GitCommitDetailWidget);
        }
    }); });
    bind(git_commit_detail_open_handler_1.GitCommitDetailOpenHandler).toSelf();
    bind(browser_1.OpenHandler).toService(git_commit_detail_open_handler_1.GitCommitDetailOpenHandler);
    browser_1.bindViewContribution(bind, git_history_contribution_1.GitHistoryContribution);
}
exports.bindGitHistoryModule = bindGitHistoryModule;
