"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var ws_connection_provider_1 = require("@devpodio/core/lib/browser/messaging/ws-connection-provider");
var git_prompt_1 = require("../../common/git-prompt");
exports.default = new inversify_1.ContainerModule(function (bind) {
    bind(git_prompt_1.GitPrompt).toSelf();
    bindPromptServer(bind);
});
function bindPromptServer(bind) {
    bind(git_prompt_1.GitPromptServer).to(git_prompt_1.GitPromptServerImpl).inSingletonScope();
    bind(git_prompt_1.GitPromptServerProxy).toDynamicValue(function (context) { return ws_connection_provider_1.WebSocketConnectionProvider.createProxy(context.container, git_prompt_1.GitPrompt.WS_PATH); }).inSingletonScope();
}
exports.bindPromptServer = bindPromptServer;
