"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var PQueue = require("p-queue");
var quick_open_model_1 = require("@devpodio/core/lib/browser/quick-open/quick-open-model");
var quick_open_service_1 = require("@devpodio/core/lib/browser/quick-open/quick-open-service");
var git_prompt_1 = require("../../common/git-prompt");
var GitQuickOpenPrompt = (function (_super) {
    __extends(GitQuickOpenPrompt, _super);
    function GitQuickOpenPrompt() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.queue = new PQueue({ autoStart: true, concurrency: 1 });
        return _this;
    }
    GitQuickOpenPrompt.prototype.ask = function (question) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2, this.queue.add(function () {
                        var details = question.details, text = question.text, password = question.password;
                        return new Promise(function (resolve) {
                            var model = {
                                onType: function (lookFor, acceptor) {
                                    acceptor([
                                        new quick_open_model_1.QuickOpenItem({
                                            label: details,
                                            run: function (mode) {
                                                if (mode !== quick_open_model_1.QuickOpenMode.OPEN) {
                                                    return false;
                                                }
                                                resolve(git_prompt_1.GitPrompt.Success.create(lookFor));
                                                return true;
                                            }
                                        })
                                    ]);
                                }
                            };
                            var options = {
                                onClose: function (canceled) {
                                    if (canceled) {
                                        resolve(git_prompt_1.GitPrompt.Cancel.create());
                                    }
                                },
                                placeholder: text,
                                password: password
                            };
                            _this.quickOpenService.open(model, options);
                        });
                    })];
            });
        });
    };
    GitQuickOpenPrompt.prototype.dispose = function () {
        if (!this.queue.isPaused) {
            this.queue.pause();
        }
        this.queue.clear();
    };
    __decorate([
        inversify_1.inject(quick_open_service_1.QuickOpenService),
        __metadata("design:type", quick_open_service_1.QuickOpenService)
    ], GitQuickOpenPrompt.prototype, "quickOpenService", void 0);
    GitQuickOpenPrompt = __decorate([
        inversify_1.injectable()
    ], GitQuickOpenPrompt);
    return GitQuickOpenPrompt;
}(git_prompt_1.GitPrompt));
exports.GitQuickOpenPrompt = GitQuickOpenPrompt;
